#!/bin/bash

# ID: irclog2sql.bash (V1.0) Sat Aug 28 02:42:56 EST 2004 ground/X
# try to import an irc log into an sql database
# This requires the replace util in your path.  This is part of mysql.
# expects to read a gcc log file from STDIN and writes SQL to STDOUT.
# Single argument is the name of the table that will hold the values.
# by default values are nick and msg which are type char.

table_name="" # cmdline
function verify_msg {
# checks to make sure this is an msg not a join ect.
local first_char header_chars
first_char=`echo "$*" |cut -b1`
if [ "$first_char" = "<" ]
then
# don't include private msgs sent by the logging user.
header_chars=`echo "$*" |cut -b1-3`
if [ "$header_chars" = "<-[" ]
then
return 1
fi
# public msgs must have a greater than symbol.
if echo "$*" |grep -q ">"
then
return 0
fi
return 1
fi
return 1
}
# End function
function sql_gen {
local nick msg line
while read line
do
if ! verify_msg "$line"
then
continue
fi
nick=`echo "$line" |cut -d ">" -f1 |tr -d "<>"`
msg=`echo "$line" |cut -d ">" -f2-255 |cut -b2-255`
echo "insert into $table_name (nick, msg) values"
echo "('${nick}', '${msg}');"
unset nick msg
done
return 0
}
# End function.
function parse_cmd {
if [ "$1" = "" ]
then
echo "Usage: $0 <table_name>"
exit 1
fi
table_name="$1"
return 0
}
# End function

parse_cmd $*
tr -d "'\002" |replace "\\" "\\\\\\\\" |sql_gen
exit 0
